A Walk Through the Forest HDU - 1142(dijkstra+动态规划)

题目大意: 给你一个图,找最短路。但是有个非一般的的条件:如果a,b之间有路, 且你选择要走这条路,那么必须保证a到终点的所有路都小于b到终点的 一条路。问满足这样的路径条数 有多少。。。

解题思路

: 1.1为起点,2为终点,因为要走ab路时,必须保证那个条件,所以从终点 开始使用单源最短路Dijkstra算法,就得到了最短的一条路,作为找路的 最低限度。

2.然后深搜每条路,看看满足题意的路径有多少条。当然,这个需要从起2 点开始搜,因为dis[i]数组中保存的都是该点到终点的最短距离。

3.这样搜索之后,dp[1]就是从起点到终点所有满足题意的路径的条数。

Jimmy experiences a lot of stress at work these days, especially since his accident made working difficult. To relax after a hard day, he likes to walk home. To make things even nicer, his office is on one side of a forest, and his house is on the other. A nice walk through the forest, seeing the birds and chipmunks is quite enjoyable. 
The forest is beautiful, and Jimmy wants to take a different route everyday. He also wants to get home before dark, so he always takes a path to make progress towards his house. He considers taking a path from A to B to be progress if there exists a route from B to his home that is shorter than any possible route from A. Calculate how many different routes through the forest Jimmy might take. 

Input

Input contains several test cases followed by a line containing 0. Jimmy has numbered each intersection or joining of paths starting with 1. His office is numbered 1, and his house is numbered 2. The first line of each test case gives the number of intersections N, 1 < N ≤ 1000, and the number of paths M. The following M lines each contain a pair of intersections a b and an integer distance 1 ≤ d ≤ 1000000 indicating a path of length d between intersection a and a different intersection b. Jimmy may walk a path any direction he chooses. There is at most one path between any pair of intersections. 

Output

For each test case, output a single integer indicating the number of different routes through the forest. You may assume that this number does not exceed 2147483647 

Sample Input

5 6
1 3 2
1 4 2
3 4 3
1 5 12
4 2 34
5 2 24
7 8
1 3 1
1 4 1
3 7 1
7 4 1
7 5 1
6 7 1
5 2 1
6 2 1
0

Sample Output

2
4
#include<stdio.h>
#include<string.h>
#include<algorithm>
using namespace std;
const int maxn = 1000+10;
const int inf=0x3f3f3f3f;
int w[maxn][maxn]; //建图
int d[maxn]; //记录的是每个点到终点的最短路径长度
int book[maxn];
int dp[maxn]; //每个点到终点的最短路径的条数
int n,m;
void Dijkstra(int aa)
{
    for(int i = 1; i <= n; i++)
        d[i] = w[aa][i];
    d[aa] = 0;
    memset(book,0,sizeof(book));
    for(int i = 1; i <= n; i++)
    {
        int x, m = inf;
        for(int y = 1; y <= n; y++)
            if(!book[y] && d[y] <= m)
            {
                m = d[y];
                x=y;
            }
        book[x] = 1;
        for(int y = 1; y <= n; y++)
            d[y] = min(d[y], d[x]+w[x][y]);
    }
}
int dfs(int u)
{
    if(dp[u] != -1)
        return dp[u]; //记忆化搜索
    if(u == 2)
        return 1; //如果到达了终点
    int sum = 0;
    for(int v = 1; v <= n; v++) //依次遍历每一个点
        if(w[u][v] != inf && d[v]<d[u]) //如果u到v有路,而且v到终点的最短路径小于 u 到终点的最小路径
            sum += dfs(v);//路径条数累加
    dp[u] = sum;
    return dp[u];//找到的所有路径的结果
}

int main()
{
    while(~scanf("%d", &n)&&n)
    {
        scanf("%d",&m);
        memset(w,inf,sizeof(w));
        memset(dp,-1,sizeof(dp));
        for(int i = 1; i <= n; i++)
            w[i][i]=0;
        int u,v,tt;
        while(m--)
        {
            scanf("%d%d%d", &u,&v,&tt);
            w[u][v] = min(w[u][v], tt); //避免重边的情况
            w[v][u] = w[u][v]; //无向图
        }//起点深搜,得到满足题意路径条数
        Dijkstra(2); //从终点2开始找最短路
        printf("%d\n", dfs(1)); //起点1到终点2的最短路的条数
    }
    return 0;
}

 

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值